#include "entities/entity.h"
#include "map/node.h"

namespace entity {

class Rainbow : public Entity {
    public:
        Rainbow() : Entity(4) { std::cout << "Rainbow construct" << std::endl; }

        Rainbow(const Rainbow &other) = default;
        Rainbow &operator=(const Rainbow &other) = default;

        virtual ~Rainbow() = default; //{ std::cout << "Rainbow destruct" << std::endl; }

        virtual Rainbow *clone() { return new Rainbow(*this); }

        void update(double dt) override;

        void set_color(Color color) { m_color = color; }
        Color color() { return m_color; }

    private:
        double m_time = 0;
        double m_prev_time = 0;

        Color m_color = Color::from_hsv(rand() % 255, 255, 255);
};

}  // End namespace entity

