#pragma once

#include <iostream>

#include "entities/entity.h"
#include "util/render.h"
#include "util/vector2.h"

#define TILE_SIZE    8

class Node;

class Tile {
    public:
        Tile() : Tile(-1) {}
        Tile(int id) : m_id(id) {}

        Tile(const Tile &other) = default;
        Tile &operator=(const Tile &other) = delete;

        virtual ~Tile() = default;

        virtual Tile *clone() { return new Tile(*this); }

        void set_node(Node *node) { m_node = node; }
        Node &node() { return *m_node; }

        virtual Entity *create_entity();

        // Get the tile's ID
        int id() { return m_id; }
        // void set_id(int id) { m_id = id; }

        virtual void render(Render r);

        friend std::ostream &operator<<(std::ostream &os, const Tile &tile);
        friend std::istream &operator>>(std::istream &is, Tile &tile);

    private:
        Node *m_node;

        int m_id;
};
